﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NPersistence.NHibernate
{
    class AvailableSettings
    {
        public static String SHARED_CACHE_RETRIEVE_MODE_JPA = "javax.persistence.cache.retrieveMode";
        public static String SHARED_CACHE_RETRIEVE_MODE = "NPersistence.cache.retrieveMode";
        
        public static String SHARED_CACHE_STORE_MODE_JPA = "javax.persistence.cache.storeMode";
        public static String SHARED_CACHE_STORE_MODE = "NPersistence.cache.storeMode";

        /**
        * Provider
        */
        public static String PROVIDER = "NPersistence.provider";
        public static String PROVIDER_JPA = "javax.persistence.provider";
        /**
         * ²
         * transaction type
         */
        public static String TRANSACTION_TYPE = "NPersistence.transactionType";
        public static String TRANSACTION_TYPE_JPA = "javax.persistence.transactionType";
        /**
         * JTA datasource name
         */
        public static String JTA_DATASOURCE = "NPersistence.jtaDataSource";
        public static String JTA_DATASOURCE_JPA = "javax.persistence.jtaDataSource";
        /**
         * Non JTA datasource name
         */
        public static String NON_JTA_DATASOURCE = "NPersistence.nonJtaDataSource";
        public static String NON_JTA_DATASOURCE_JPA = "javax.persistence.nonJtaDataSource";

        /**
	     * Used to request (hint) a pessimistic lock scope.
	     * <p/>
	     * See JPA 2 sections 8.2.1.9 and 3.4.4.3
	     */
	    public static String LOCK_SCOPE = "NPersistence.lock.scope";
        public static String LOCK_SCOPE_JPA = "javax.persistence.lock.scope";

	    /**
	     * Used to request (hint) a pessimistic lock timeout (in milliseconds).
	     * <p/>
	     * See JPA 2 sections 8.2.1.9 and 3.4.4.3
	     */
	    public static String LOCK_TIMEOUT = "NPersistence.lock.timeout";
        public static String LOCK_TIMEOUT_JPA = "javax.persistence.lock.timeout";

        /**
    	 * Used to determine flush mode.
	     */
	    //Use the org.hibernate prefix. instead of hibernate. as it is a query hint se QueryHints
        public static String FLUSH_MODE = "NHibernate.flushMode";
	    public static String FLUSH_MODE_JPA = "org.hibernate.flushMode";  

       	/**
	     * Whether or not to discard persistent context on entityManager.close()
	     * The EJB3 compliant and default choice is false
	     */
	    public static String DISCARD_PC_ON_CLOSE = "hibernate.ejb.discard_pc_on_close";

        /**
	    * Interceptor class name, the class has to have a no-arg constructor
	    */
	    public static String SESSION_INTERCEPTOR = "hibernate.ejb.interceptor.session_scoped";

        /**
         * 
         */
        public static String TEMP_FILES_OUTPUT_FOLDER = "hibernate.temp_files_output_folder";

    }
}
