﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NPersistence;
using NHibernate.Impl;
using NPersistence.spi;
using NHibernate;

namespace NPersistence.NHibernate
{
    public class EntityManagerFactoryImpl : EntityManagerFactory
    {
        private ISessionFactory m_sessionFactory;
        private PersistenceUnitTransactionType m_transactionType;
        private Type m_sessionInterceptorClass;
        private bool m_discardOnClose;

        public EntityManagerFactoryImpl(ISessionFactory sessionFactory, 
            PersistenceUnitTransactionType transactionType, 
            Type sessionInterceptorClass,
            bool discardOnClose)
        {
            this.m_sessionFactory = sessionFactory;
            m_transactionType = transactionType;
            m_sessionInterceptorClass = sessionInterceptorClass;
            m_discardOnClose = discardOnClose;
        }

        public EntityManager CreateEntityManager()
        {
            return CreateEntityManager(null);
        }


        public EntityManager CreateEntityManager(Dictionary<object, object> properties)
        {
            return new EntityManagerImpl(m_sessionFactory, properties, this, m_transactionType, PersistenceContextType.EXTENDED, m_sessionInterceptorClass, m_discardOnClose);
        }

        public bool IsOpen()
        { 
            throw new NotImplementedException("not implemented yet");
        }

        public void Close()
        {
            throw new NotImplementedException("not implemented yet");
        }

        public Dictionary<string, object> GetProperties()
        {
            throw new NotImplementedException("not implemented yet");
        }

        public Cache GetCache()
        {
            throw new NotImplementedException("not implemented yet");
        }

        public PersistenceUnitUtil GetPersistenceUnitUtil()
        {
            throw new NotImplementedException("not implemented yet");
        }
    }
}
