﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace NPersistence.NHibernate.Event
{
    public class CallbackMethod
    {
        private Object invoker;
        private MethodInfo method;
        /// <summary>
        /// 
        /// </summary>
        /// <param name="invoker">null for an internal entity callback method or an instance of the
        /// callback class for external callback object.
        /// </param>
        public CallbackMethod(Object invoker, MethodInfo method)
        {
            this.invoker = invoker;
            this.method = method;
        }

        public void invokeCallback(Object entity)
        {
            Object invokerObject;
            Object[] args;
            // internal entity callback method
            if (invoker == null)
            {
                invokerObject = entity;
                args = new Object[] { };
            }
            else
            {
                invokerObject = invoker;
                args = new Object[] { entity };
            }
            method.Invoke(invokerObject, args);
        }

        internal bool isInternal()
        {
            return invoker == null;
        }

        public string Name
        {
            get
            {
                return method.Name;
            }
        }
    }
}
