﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate.Event;
using System.Reflection;

namespace NPersistence.NHibernate.Event
{
    class PostLoadCallbackHandler : CallbackHandler, IPostLoadEventListener
    {
        private static PostLoadCallbackHandler INSTANCE = null;

        private PostLoadCallbackHandler() { }

        public static PostLoadCallbackHandler getInstance()
        {
            if (INSTANCE == null)
            {
                lock (typeof(PostLoadCallbackHandler))
                {
                    if (INSTANCE == null)
                    {
                        INSTANCE = new PostLoadCallbackHandler();
                    }
                }
            }
            return INSTANCE;
        }


        public void OnPostLoad(PostLoadEvent @event)
        {
            invokeCallback(@event.Entity);
        }
    }
}
