﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate.Event;
using System.Reflection;

namespace NPersistence.NHibernate.Event
{
    class PostPersistCallbackHandler : CallbackHandler, IPostInsertEventListener
    {
        private static PostPersistCallbackHandler INSTANCE = null;

        private PostPersistCallbackHandler() { }

        public static PostPersistCallbackHandler getInstance()
        {
            if (INSTANCE == null)
            {
                lock (typeof(PostPersistCallbackHandler))
                {
                    if (INSTANCE == null)
                    {
                        INSTANCE = new PostPersistCallbackHandler();
                    }
                }
            }
            return INSTANCE;
        }

        public void OnPostInsert(PostInsertEvent @event)
        {
            invokeCallback(@event.Entity);
        }
    }
}
