﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate.Event;
using System.Reflection;

namespace NPersistence.NHibernate.Event
{
    class PostRemoveCallbackHandler : CallbackHandler, IPostDeleteEventListener
    {
         private static PostRemoveCallbackHandler INSTANCE = null;

         private PostRemoveCallbackHandler() { }

         public static PostRemoveCallbackHandler getInstance()
        {
            if (INSTANCE == null)
            {
                lock (typeof(PostRemoveCallbackHandler))
                {
                    if (INSTANCE == null)
                    {
                        INSTANCE = new PostRemoveCallbackHandler();
                    }
                }
            }
            return INSTANCE;
        }
        public void OnPostDelete(PostDeleteEvent @event)
        {
            invokeCallback(@event.Entity);
        }
    }
}
