﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate.Event;
using System.Reflection;

namespace NPersistence.NHibernate.Event
{
    class PostUpdateCallbackHandler : CallbackHandler, IPostUpdateEventListener
    {
        private static PostUpdateCallbackHandler INSTANCE = null;

        private PostUpdateCallbackHandler() { }

        public static PostUpdateCallbackHandler getInstance()
        {
            if (INSTANCE == null)
            {
                lock (typeof(PostUpdateCallbackHandler))
                {
                    if (INSTANCE == null)
                    {
                        INSTANCE = new PostUpdateCallbackHandler();
                    }
                }
            }
            return INSTANCE;
        }
        public void OnPostUpdate(PostUpdateEvent @event)
        {
            invokeCallback(@event.Entity);
        }
    }
}
