﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate.Event;
using System.Reflection;

namespace NPersistence.NHibernate.Event
{
    class PrePersistCallbackHandler : CallbackHandler, IPreInsertEventListener
    {
         private static PrePersistCallbackHandler INSTANCE = null;

         private PrePersistCallbackHandler() { }

         public static PrePersistCallbackHandler getInstance()
        {
            if (INSTANCE == null)
            {
                lock (typeof(PrePersistCallbackHandler))
                {
                    if (INSTANCE == null)
                    {
                        INSTANCE = new PrePersistCallbackHandler();
                    }
                }
            }
            return INSTANCE;
        }
        public bool OnPreInsert(PreInsertEvent @event)
        {
            invokeCallback(@event.Entity);
            return false;
        }
    }
}
