﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate.Event;
using System.Reflection;

namespace NPersistence.NHibernate.Event
{
    class PreRemoveCallbackHandler : CallbackHandler, IPreDeleteEventListener
    {
         private static PreRemoveCallbackHandler INSTANCE = null;

         private PreRemoveCallbackHandler() { }

         public static PreRemoveCallbackHandler getInstance()
        {
            if (INSTANCE == null)
            {
                lock (typeof(PreRemoveCallbackHandler))
                {
                    if (INSTANCE == null)
                    {
                        INSTANCE = new PreRemoveCallbackHandler();
                    }
                }
            }
            return INSTANCE;
        }
        public bool OnPreDelete(PreDeleteEvent @event)
        {
            invokeCallback(@event.Entity);
            return false;
        }
    }
}
