﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate.Event;
using System.Reflection;

namespace NPersistence.NHibernate.Event
{
    class PreUpdateCallbackHandler : CallbackHandler, IPreUpdateEventListener
    {
         private static PreUpdateCallbackHandler INSTANCE = null;

         private PreUpdateCallbackHandler() { }

         public static PreUpdateCallbackHandler getInstance()
        {
            if (INSTANCE == null)
            {
                lock (typeof(PreUpdateCallbackHandler))
                {
                    if (INSTANCE == null)
                    {
                        INSTANCE = new PreUpdateCallbackHandler();
                    }
                }
            }
            return INSTANCE;
        }
        public bool OnPreUpdate(PreUpdateEvent @event)
        {
            invokeCallback(@event.Entity);
            return false;
        }
    }
}
