﻿using System;
using System.Collections.Generic;
using NPersistence.spi;
using NPersistence;
using NPersistence.NHibernate.util;

namespace NPersistence.NHibernate
{
    public class NHibernatePersistence : PersistenceProvider
    {
        
        private ProviderUtil m_providerUtil = new ProviderUtilImpl();

        /**
	    * Get an entity manager factory by its entity manager name and given the
	    * appropriate extra properties. Those proeprties override the one get through
	    * the peristence.xml file.
	    */
        public EntityManagerFactory CreateEntityManagerFactory(string persistenceUnitName, Dictionary<object, object> overridenProperties)
        {
            NHibernateConfiguration cfg = new NHibernateConfiguration();
            NHibernateConfiguration configured = cfg.Configure(persistenceUnitName, overridenProperties);
            return configured != null ? configured.BuildEntityManagerFactory() : null;
        }


        public EntityManagerFactory CreateContainerEntityManagerFactory(
            PersistenceUnitInfo info, Dictionary<object, object> overridenProperties)
        {
            return null;
            //NHibernateConfiguration cfg = new NHibernateConfiguration();
            //NHibernateConfiguration configured = cfg.Configure(info, overridenProperties);
            //return configured != null ? configured.BuildEntityManagerFactory() : null;
        }

        public ProviderUtil GetProviderUtil()
        {
            return m_providerUtil;
        }

    }

    public class ProviderUtilImpl : ProviderUtil
    {
        private MetadataCache m_cache = new MetadataCache();

        public LoadState IsLoadedWithoutReference(object entity, string attributeName)
        {
            return PersistenceUtilHelper.IsLoadedWithoutReference(entity, attributeName, m_cache);
        }

        public LoadState IsLoadedWithReference(object entity, string attributeName)
        {
            return PersistenceUtilHelper.IsLoadedWithReference(entity, attributeName, m_cache);
        }

        public LoadState IsLoaded(object entity)
        {
            return PersistenceUtilHelper.isLoaded(entity);
        }
    }
}
