using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Reflection;
using NPersistence.NHibernate.src.annotationSupport.mapping;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
	public partial class HbmBag : RelationObject
	{
        private String mappedBy = null;
        private Type targetType = null;
        public HbmBag(PropertyHelper propertyInfo)
            : this()
        {
            RelationUtils.handleRelation(ref this.name, propertyInfo, ref this.Item, ref this.lazy, ref this.lazySpecified, ref this.table, ref this.schema, ref this.catalog, ref this.key, ref targetType, ref this.cascade, ref this.inverse, false, ref this.orderby, ref this.mappedBy);
            MappingCache.getInstance().registerRelation(propertyInfo.getPath(), propertyInfo.ReflectedType, this);
        }

        public bool isIndexed()
        {
            return false;
        }

        public String getMappedBy()
        {
            return mappedBy;
        }

        public Type getTargetType()
        {
            return targetType;
        }

		#region Implementation of IEntityPropertyMapping

		public string Name
		{
			get { return name; }
		}

		public string Access
		{
			get { return access; }
		}

		public bool IsLazyProperty
		{
			get { return false; }
		}

		public bool OptimisticLock
		{
			get { return optimisticlock; }
		}

		#endregion

		#region Implementation of IReferencePropertyMapping

		public string Cascade
		{
			get { return cascade; }
		}

		#endregion

		#region Overrides of AbstractDecoratable

		protected HbmMeta[] Metadatas
		{
			get { return meta ?? new HbmMeta[0]; }
		}

		#endregion

		#region Implementation of ICollectionSqlsMapping

		public HbmLoader SqlLoader
		{
			get { return loader; }
		}

		public HbmCustomSQL SqlInsert
		{
			get { return sqlinsert; }
		}

		public HbmCustomSQL SqlUpdate
		{
			get { return sqlupdate; }
		}

		public HbmCustomSQL SqlDelete
		{
			get { return sqldelete; }
		}

		public HbmCustomSQL SqlDeleteAll
		{
			get { return sqldeleteall; }
		}

		#endregion

		#region Implementation of ICollectionPropertiesMapping

		public bool Inverse
		{
			get { return inverse; }
		}

		public bool Mutable
		{
			get { return mutable; }
		}

		public string OrderBy
		{
			get { return orderby; }
		}

		public string Where
		{
			get { return where; }
		}

		public int? BatchSize
		{
			get { return batchsizeSpecified ? batchsize: (int?) null; }
		}

		public string PersisterQualifiedName
		{
			get { return persister; }
		}

		public string CollectionType
		{
			get { return collectiontype; }
		}

		public HbmCollectionFetchMode? FetchMode
		{
			get { return fetchSpecified ? fetch: (HbmCollectionFetchMode?) null; }
		}

		public HbmOuterJoinStrategy? OuterJoin
		{
			get { return outerjoinSpecified ? outerjoin:(HbmOuterJoinStrategy?) null; }
		}

		public HbmCollectionLazy? Lazy
		{
			get { return lazySpecified ? lazy : (HbmCollectionLazy?)null; }
		}

		public string Table
		{
			get { return table; }
		}

		public string Schema
		{
			get { return schema; }
		}

		public string Catalog
		{
			get { return catalog; }
		}

		public string Check
		{
			get { return check; }
		}

		public object ElementRelationship
		{
			get { return Item; }
		}

		public string Sort
		{
			get { return null; }
		}

		public bool? Generic
		{
			get { return genericSpecified ? generic: (bool?) null; }
		}

		[XmlIgnore]
		public IEnumerable<HbmFilter> Filters
		{
			get { return filter ?? new HbmFilter[0]; }
		}

		public HbmKey Key
		{
			get { return key; }
		}

		public HbmCache Cache
		{
			get { return cache; }
		}

		#endregion
	}
}