using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Serialization;
using System.Reflection;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
	public partial class HbmCompositeElement 
	{
        public HbmCompositeElement(Type targetType, PropertyHelper holdingProperty)
            : this()
        {
            this.@class = MappingUtils.getStringClassDef(targetType);
            List<object> itemsList = new List<object>();
            Object[] tempArr = new Object[1];
            foreach (PropertyHelper propertyInfo in MappingUtils.getProperties(targetType, holdingProperty))
            {
                Type type = propertyInfo.PropertyType;
                if (type.IsArray
                    || MappingUtils.isCollection(type)
                    || propertyInfo.getSingleAttribute<Transient>() != null
                    || propertyInfo.getSingleAttribute<OneToOne>() != null)
                {
                    continue;
                }
                if (propertyInfo.getSingleAttribute<ManyToOne>() != null)
                {
                    tempArr[0] = new HbmManyToOne(propertyInfo);
                    itemsList.Add(tempArr[0]);
                }
                else if (MappingUtils.isEmbeddable(type) && propertyInfo.getSingleAttribute<Embedded>() != null)
                {
                     tempArr[0] = new HbmNestedCompositeElement(propertyInfo);
                    itemsList.Add(tempArr[0]);
                }
                else
                {
                    tempArr[0] = new HbmProperty(propertyInfo);
                    itemsList.Add(tempArr[0]);
                }
            }

            this.Items = itemsList.ToArray();
        }

		#region Implementation of IComponentMapping

		public string Class
		{
			get { return @class; }
		}

		public HbmParent Parent
		{
			get { return parent; }
		}

		public string EmbeddedNode
		{
			get { return node;}
		}

		public string Name
		{
			get { return null; }
		}

		#endregion

		#region Overrides of AbstractDecoratable

		protected HbmMeta[] Metadatas
		{
			get { return meta ?? new HbmMeta[0]; }
		}

		#endregion

		
	}
}