using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Serialization;
using System.Reflection;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
	public partial class HbmCompositeMapKey
	{
        public HbmCompositeMapKey(PropertyHelper holdingProperty, Type mapKeyClass)
            : this()
        {
            this.@class = MappingUtils.getStringClassDef(mapKeyClass);
            List<object> itemsList = new List<object>();
            foreach (PropertyHelper propertyInfo in MappingUtils.getProperties(mapKeyClass, holdingProperty))
            {
                Type type = propertyInfo.PropertyType;
                if(type.IsArray 
                    || MappingUtils.isCollection(type)
                    || propertyInfo.getSingleAttribute<Transient>() != null
                    || propertyInfo.getSingleAttribute<OneToOne>() != null
                    || MappingUtils.isEmbeddable(type))
                {
                    continue;
                }
                itemsList.Add(new HbmKeyProperty(propertyInfo));
            }
            this.Items = itemsList.ToArray();
        }
                
		#region Implementation of IComponentMapping

		public string Class
		{
			get { return @class; }
		}

		public HbmParent Parent
		{
			get { return null; }
		}

		public string EmbeddedNode
		{
			get { return null; }
		}

		public string Name
		{
			get { return null; }
		}

		#endregion
	}
}