using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using NPersistence.NHibernate.src.annotationSupport.mapping;
using System.Reflection;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
	public partial class HbmId
	{
        public HbmId(PropertyHelper propertyInfo)
            : this()
        {
            name = propertyInfo.Name;
            type1 = propertyInfo.PropertyType.FullName;

            object[] attributes = propertyInfo.GetCustomAttributes(false);
            object genrtor = null;
            object generateVal = null;

            foreach (object attr in attributes)
            {
                if (attr is Column)
                {
                    column = new HbmColumn[1];
                    column[0] = new HbmColumn((Column)attr, null);
                }
                else if (attr is TableGenerator || attr is SequenceGenerator )
                {
                    genrtor = attr;
                }
                else if (attr is GeneratedValue)
                {
                    generateVal = attr;
                }

            }

            if (generateVal != null)
            {
                generator = new HbmGenerator((GeneratedValue)generateVal, genrtor);
            }
        }

        
		[XmlIgnore]
		public IEnumerable<HbmColumn> Columns
		{
			get { return column ?? AsColumns(); }
		}


		private IEnumerable<HbmColumn> AsColumns()
		{
			if (string.IsNullOrEmpty(column1))
			{
				yield break;
			}
			else
			{
				yield return new HbmColumn
				{
					name = column1,
					length = length,
				};
			}
		}

		protected HbmMeta[] Metadatas
		{
			get { return meta ?? new HbmMeta[0]; }
		}

		public HbmType Type
		{
			get { return type ?? (!string.IsNullOrEmpty(type1) ? new HbmType { name = type1 } : null); }
		}

	}
}