using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Reflection;
using NPersistence.NHibernate.src.annotationSupport.mapping;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
	public partial class HbmKeyProperty 
	{
        public HbmKeyProperty(PropertyHelper propertyInfo)
            : this()
        {
            this.name = propertyInfo.Name;
            object[] colsArr = null;
            PropertyUtils.handleColumn(propertyInfo, ref colsArr);
            this.column = new HbmColumn[] { (HbmColumn)colsArr[0] };
            PropertyUtils.handlePropertyType(propertyInfo, propertyInfo.PropertyType, this.column[0], ref this.type1, false);
        }


		#region Implementation of IColumnsMapping

		[XmlIgnore]
		public IEnumerable<HbmColumn> Columns
		{
			get { return column ?? AsColumns(); }
		}

		#endregion

		private IEnumerable<HbmColumn> AsColumns()
		{
			if (string.IsNullOrEmpty(column1))
			{
				yield break;
			}
			else
			{
				yield return new HbmColumn
				{
					name = column1,
					length = length,
				};
			}
		}

		#region Implementation of ITypeMapping

		public HbmType Type
		{
			get { return type ?? (!string.IsNullOrEmpty(type1) ? new HbmType { name = type1 } : null); }
		}

		#endregion

		#region Overrides of AbstractDecoratable

		protected HbmMeta[] Metadatas
		{
			get { return meta ?? new HbmMeta[0]; }
		}

		#endregion

		#region Implementation of IEntityPropertyMapping

		public string Name
		{
			get { return name; }
		}

		public bool IsLazyProperty
		{
			get { return false; }
		}

		public string Access
		{
			get { return access; }
		}

		public bool OptimisticLock
		{
			get { return false; }
		}

		#endregion
	}
}