using System.Collections.Generic;
using System.Xml.Serialization;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
	public partial class HbmListIndex
	{

        public HbmListIndex(OrderColumn orderColumn, string propertyName)
            : this()
        {
            if (orderColumn == null)
            {
                orderColumn = new OrderColumn();
            }
            if (orderColumn.Name == null || orderColumn.Name.Length == 0)
            {
                orderColumn.Name = propertyName + "_" + "ORDER";
            }
            this.column = new HbmColumn(orderColumn);
        }

		[XmlIgnore]
		public IEnumerable<HbmColumn> Columns
		{
			get
			{
				if (column != null)
				{
					yield return column;
				}
				else if (string.IsNullOrEmpty(column1))
				{
					yield break;
				}
				else
				{
					yield return new HbmColumn
					{
						name = column1,
					};
				}
			}
		}
	}
}