using System.Xml;
using System;
namespace NPersistence.NHibernate.annotationSupport.mapping
{
    partial class HbmQuery : HbmBase
    {
        public HbmQuery(NamedQuery query)
            : this()
        {
            this.cacheable = false;
            this.name = query.Name;
            this._Text = query.Query;
        }

        [System.Xml.Serialization.XmlText]
        public XmlNode[] Text
        {
            get
            {
                var dummy = new XmlDocument();
                return new XmlNode[] { dummy.CreateCDataSection(_Text) };
            }
            set
            {
                if (value == null)
                {
                    _Text = null;
                    return;
                }

                if (value.Length != 1)
                {
                    throw new InvalidOperationException(
                        String.Format(
                            "Invalid array length {0}", value.Length));
                }

                var node0 = value[0];
                var cdata = node0 as XmlCDataSection;
                if (cdata == null)
                {
                    throw new InvalidOperationException(
                        String.Format(
                            "Invalid node type {0}", node0.NodeType));
                }

                _Text = cdata.Data;
            }
        }
    }
}