using System.Collections.Generic;
using System.Xml.Serialization;
using NPersistence.Ext;
using System.Reflection;
using NPersistence.NHibernate.src.annotationSupport.mapping;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
	partial class HbmVersion
	{
        public HbmVersion(PropertyHelper propertyInfo)
            : this()
        {
            this.name = propertyInfo.Name;
            //handle column
            object[] colsArr = null;
            PropertyUtils.handleColumn(propertyInfo, ref colsArr);
            this.column = new HbmColumn[] { (HbmColumn)colsArr[0] };
            HbmColumn hbmCol = this.column[0];

            Temporal temporal = propertyInfo.getSingleAttribute<Temporal>();
            if (temporal != null && TemporalType.TIMESTAMP.Equals(temporal.Value))
            {
                this.type = "timestamp";
            }
            else
            {
                PropertyUtils.handlePropertyType(propertyInfo, propertyInfo.PropertyType, hbmCol, ref this.type, false);
            }
        }


		protected HbmMeta[] Metadatas
		{
			get { return meta ?? new HbmMeta[0]; }
		}

		#region Implementation of IColumnsMapping

		[XmlIgnore]
		public IEnumerable<HbmColumn> Columns
		{
			get { return column ?? AsColumns(); }
		}

		#endregion

		private IEnumerable<HbmColumn> AsColumns()
		{
			if (string.IsNullOrEmpty(column1))
			{
				yield break;
			}
			else
			{
				yield return new HbmColumn
				{
					name = column1,
				};
			}
		}
	}
}