﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NPersistence;

namespace NPersistence.NHibernate.query
{
    class ParameterImpl<T> : Parameter<T>
    {
        private Type m_type;
        private int? m_position;
        private string m_name;
        
        public ParameterImpl(string name, Type type)
        {
            m_name = name;
            m_type = type;
        }

        public ParameterImpl(int position, Type type)
        {
            m_position = position;
            m_type = type;
        }

        public ParameterImpl(string name, int? position, Type type)
        {
            m_name = name;
            m_position = position;
            m_type = type;
        }

        public override bool Equals(object obj)
        {
            if (this == obj)
            {
                return true;
            }
            if (!(obj is ParameterImpl<T>))
            {
                return false;
            }
            
            ParameterImpl<T> other = (ParameterImpl<T>)obj;

            if (!m_type.Equals(other.m_type))
            {
                return false;
            }

            if (m_name != null)
            {
                return m_name.Equals(other.m_name);
            }

            return m_position.Equals(other.m_position);
        }

        public override int GetHashCode()
        {
            if (m_name != null)
            {
                return m_name.GetHashCode();
            }
            return m_position.GetHashCode();
        }
        
        string Parameter<T>.GetName()
        {
            return m_name;
        }

        int? Parameter<T>.GetPosition()
        {
            return m_position;
        }

        Type Parameter<T>.GetParameterType()
        {
            return m_type;
        }
    }
}
